///+------------------------------------------------------------------+
//|                                             N0_iWPR_LOCK_SUM.mq4 |
//|                                  Copyright  2007, Tradersforum. |
//|                                  http://www.tradersforum.net.ru/ | 
//|                                     Leonid553 & NoName(-and)     |
//+------------------------------------------------------------------+

#property copyright "Leonid553  http://www.tradersforum.net.ru/forum/"
#property link      "http://www.tradersforum.net.ru/"

//---- input parameters
extern int  WPR_period=6;
extern int  x1 = 108; extern int x2 = 98; extern int x3 = 78; extern int x4 = 108;
extern int  A1 = 91;  extern int A2 = 91;
extern int  y1 = 95; extern int y2 = 101; extern int y3 = 96; extern int y4 = 108;
extern int  z1 = 87; extern int z2 = 98; extern int z3 = 84; extern int z4 = 108;
// StopLoss level
extern int    sl = 79;
extern int    tp = 158;
extern int    sl_l=63;
extern int    tp_l=100;
extern int    sl_2=66;
extern int    tp_2=171;
//extern double lots = 0.1;
extern int    MagicNumber = 531;
extern int    MagicNumberLock=787;
extern int m1=-42;
extern int m2=-52;
static int prevtime = 0;
static int spread = 3;
//--- ------------
extern int   P_1=0; extern int P_2=7; extern int P_3=14; extern int P_4=21;
extern int   A_1=5; extern int  A_2=10;
//--   --
#include  <b-Lots.mqh>  // 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {  
    Comment(perceptron());          
  //    v        
   if(Time[0] == prevtime) // ,    
       return(0);
   prevtime = Time[0];
   
//----
   if(IsTradeAllowed()) 
     {
       spread = MarketInfo(Symbol(), MODE_SPREAD);
     } 
   else 
     {
       prevtime = Time[1];
       return(0);
     }
   int ticket = -1;
   //    
   int total = OrdersTotal();   
   for(int i = 0; i < total; i++) 
     {
          OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       //     magic number
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {              
           int prevticket = OrderTicket();         
           if(OrderType() == OP_BUY) 
             {  //           
 //*********************************************************
              if ( total<2 && perceptron1() < 0 && OrderProfit() < (m1)  )                                   
              {  
                 Lots=GetSizeLot();//   -   b-Lots
                 ticket = OrderSend(Symbol(), OP_SELL, Lots , Bid, 3, 
                      Bid + sl_l * Point,Bid-tp_l*Point, "LO", MagicNumberLock, 
                                          0, Yellow);
                       Sleep(30000);
                       if(ticket < 0)  prevtime = Time[1];// . 
                    }                                                                              
  //***********************************************************************                                                                  
        
                    if(Bid > (OrderStopLoss() + (tp  + spread) * Point)) 
                 { //    tp    0               
                   if(perceptron() < 0) 
                     { 
                       // -  
                       if (!OrderClose (prevticket, OrderLots(), Bid, 2, Blue) ) 
                       {Print("   #", GetLastError());}
                       else {
                       Lots=GetSizeLot();//   -   b-Lots
                       ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, 
                                          Ask + sl * Point, 0, "WPR", MagicNumber, 
                                          0, Red); 
                       }                    
                     } 
                   else 
                     { //    -   -
                       // trailing stop
                       if(!OrderModify(OrderTicket(), OrderOpenPrice(), 
                          Bid - sl * Point, 0, 0, Blue)) 
                         {
                           Sleep(30000);
                           prevtime = Time[1];
                         }
                      }
                  }  
              } 
           else 
             {  //         
 //*********************************************************
      if ( total<2 && (perceptron2() > 0) && OrderProfit() < (m2)  )  
                   {    Lots=GetSizeLot();//   -   b-Lots
                        ticket = OrderSend(Symbol(), OP_BUY, Lots , Bid, 3, 
                      Bid - sl_2 * Point,Ask+tp_2*Point, "LO", MagicNumberLock, 
                                          0, Black);
                                       Sleep(30000);
                         if(ticket < 0)  prevtime = Time[1];// .                                                               
                     }                                                    
                                                                
    //***********************************************************************            
              if(Ask < (OrderStopLoss() - (tp + spread) * Point)) 
                 {  //      tp    0             
                   if(perceptron() > 0) 
                     { 
                       //   
                       if (!OrderClose (prevticket, OrderLots(), Ask, 2, Blue) ) 
                       {Print("   #", GetLastError());}
                       else {
                       Lots=GetSizeLot();//   -   b-Lots
                       ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, 
                                          Bid - sl * Point, 0, "WPR", MagicNumber,
                                          0, Blue);
                       }              
                     }                  
                   else //     -   -
                     { 
                       // trailing stop
                       if(!OrderModify(OrderTicket(), OrderOpenPrice(), 
                          Ask + sl * Point, 0, 0, Blue)) 
                         {
                           Sleep(30000);
                           prevtime = Time[1];
                         }  
                     }
                 }  
             }
           // exit
           return(0);
         }
     }
//******************************************************************************
   //     
   if(perceptron() > 0) 
     {        //long
       Lots=GetSizeLot();  //  
       ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Bid - sl * Point, 0, 
                      "WPR", MagicNumber, 0, Blue); 
       if(ticket < 0) 
         { Sleep(30000);  prevtime = Time[1]; }
     }       
   
   else 
     {        // short
       Lots=GetSizeLot();   //  
       ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Ask + sl * Point, 0, 
                      "WPR", MagicNumber, 0, Red); 
       if(ticket < 0) 
         { Sleep(30000); prevtime = Time[1];}
     }
//--- exit
   return(0);
  }
//+------------------------------------------------------------------+
//|  The PERCEPTRON - a perceiving and recognizing function          |
//+------------------------------------------------------------------+
double perceptron() 
  {
   double w1 = x1 - 100.0;
   double w2 = x2 - 100.0;
   double w3 = x3 - 100.0;
   double w4 = x4 - 100.0;
     double w5 = A1 - 100.0;
     double w6 = A2 - 100.0;
   double a1 = iWPR(Symbol(),  0,WPR_period,  P_1)+50; 
   double a2 = iWPR(Symbol(),  0,WPR_period,  P_2)+50;
   double a3 = iWPR(Symbol(),  0,WPR_period,  P_3)+50;
   double a4 = iWPR(Symbol(),  0,WPR_period,  P_4)+50;
     double a5 = iWPR(Symbol(), 0,WPR_period,  A_1)+50;
     double a6 = iWPR(Symbol(), 0,WPR_period,  A_2)+50;
   return (w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4 + w5 * a5 + w6 * a6);
  }   
//--------------------------------------------------------------------
 double perceptron1() //  
  {
   double w1 = y1 - 100.0;
   double w2 = y2 - 100.0;
   double w3 = y3 - 100.0;
   double w4 = y4 - 100.0;
     //double w5 = A1 - 100.0;
     //double w6 = A2 - 100.0;
   double a1 = iWPR(Symbol(),  0,WPR_period,   0)+50; 
   double a2 = iWPR(Symbol(),  0,WPR_period,   7)+50;
   double a3 = iWPR(Symbol(),  0,WPR_period,  14)+50;
   double a4 = iWPR(Symbol(),  0,WPR_period,  21)+50;
     //double a5 = iWPR(Symbol(), 0,WPR_period,  A_1)+50;
     //double a6 = iWPR(Symbol(), 0,WPR_period,  A_2)+50;
   return (w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4); // + w5 * a5 + w6 * a6);
  }  
//--------------------------------------------------------------------  
 double perceptron2() // 
  {
   double w1 = z1 - 100.0;
   double w2 = z2 - 100.0;
   double w3 = z3 - 100.0;
   double w4 = z4 - 100.0;
     //double w5 = A1 - 100.0;
     //double w6 = A2 - 100.0;
   double a1 = iWPR(Symbol(),  0,WPR_period,   0)+50; 
   double a2 = iWPR(Symbol(),  0,WPR_period,   7)+50;
   double a3 = iWPR(Symbol(),  0,WPR_period,  14)+50;
   double a4 = iWPR(Symbol(),  0,WPR_period,  21)+50;
     //double a5 = iWPR(Symbol(), 0,WPR_period,  A_1)+50;
     //double a6 = iWPR(Symbol(), 0,WPR_period,  A_2)+50;
   return (w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4); // + w5 * a5 + w6 * a6);
  }
  //+-----------------------------------------------------------------------------------+
 
  